-- Core Lua File for EssencesTalentsTab
local addonName, addonTable = ...

local EssencesTalentsTab = LibStub("AceAddon-3.0"):NewAddon(
	"EssencesTalentsTab", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0"
);

EssencesTalentsTab.Version = GetAddOnMetadata(addonName, "Version")
addonTable[1] = EssencesTalentsTab

_G[addonName] = EssencesTalentsTab

EssencesTalentsTab.essencesTalentsTabCreated = false

function EssencesTalentsTab:OnInitialize()

	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
end

function EssencesTalentsTab:PLAYER_ENTERING_WORLD()

	TalentFrame_LoadUI()
	self:SecureHook("ToggleTalentFrame", "OnPlayerTalentsOpen", true)
	
end

function EssencesTalentsTab:OnPlayerTalentsOpen()

	if self.essencesTalentsTabCreated == false then
		self:CreateEssencesTalentsTab()
	end

end

function EssencesTalentsTab:CreateEssencesTalentsTab()

	TalentFrame_LoadUI()
	local talentsFrameNumTab = PlayerTalentFrame.numTabs + 1

	talentsTab = CreateFrame('Button', 'PlayerTalentFrame' .. talentsFrameNumTab, PlayerTalentFrame, 'UIPanelButtonTemplate')
	talentsTab:SetText("Essences")
	talentsTab:SetWidth(150)
	talentsTab:SetID(talentsFrameNumTab)
	talentsTab:SetScript("OnClick", function (self, button, down)
		LoadAddOn("Blizzard_AzeriteEssenceUI")
		if AzeriteEssenceUI:IsVisible() then 
			HideUIPanel(AzeriteEssenceUI)
		else 
			ShowUIPanel(AzeriteEssenceUI)
		end
	end)
	talentsTab:SetNormalFontObject(GameFontHighlightSmall)
	talentsTab:SetPoint('LEFT', _G['PlayerTalentFrameTab' .. talentsFrameNumTab - 1], 'RIGHT', -8, 0)
	talentsTab:Show()
	
	self.essencesTalentsTabFrame = talentsTab

	self.essencesTalentsTabCreated = true

	self:Unhook("ToggleTalentFrame")

end